// DftFftView.cpp : CDftFftView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/16

#include "stdafx.h"
#include "DftFft.h"

#include "DftFftDoc.h"
#include "DftFftView.h"
#include "DlgIteration.h"
#include "DlgScale.h"
#include "DlgFft.h"
#include "DlgFftPos.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDftFftView

IMPLEMENT_DYNCREATE(CDftFftView, CView)

BEGIN_MESSAGE_MAP(CDftFftView, CView)
	//{{AFX_MSG_MAP(CDftFftView)
	ON_COMMAND(ID_MENU_LD, OnMenuLd)
	ON_COMMAND(ID_MENU_ITR, OnMenuItr)
	ON_COMMAND(ID_MENU_RNG, OnMenuRng)
	ON_COMMAND(ID_MENU_FFT, OnMenuFft)
	ON_COMMAND(ID_MENU_FFTPOS, OnMenuFftpos)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDftFftView NX̍\z/

CDftFftView::CDftFftView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	docalc = FALSE;
	sel_fft = FALSE;
	spec_range = 1000000.0;
	freq_range = 44100.0;
	Iteration = 1;
	mono1_stereo2 = 1;
	samplingfreq = 44100;
	bitlength = 8;
	totalbytes = 44100;
	bytesinfile = 44100;
	chbytes_per_sample = 1;
	bytes_per_sample = 1;
	bytes_per_sec = 44100;
	wavesize = 44100;
	timelength = 1;
	dotn = 500;
	allocated = FALSE;
	loaded = FALSE;
	xstart = 0;
	yrng = 10000;
	fft_position = 20;
}

CDftFftView::~CDftFftView()
{
}

BOOL CDftFftView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDftFftView NX̕`

void CDftFftView::OnDraw(CDC* pDC)
{
	CDftFftDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	int i;
	if(loaded) {
		InfoDraw(pDC, 80, 20);
		if(docalc) {
			for(i = 0; i < Iteration; i++) {
				if(!sel_fft) DftCal(InWave, Spectrum);
				else FftCal(InWave, Spectrum);
			}
			docalc = FALSE;
		}
		FftDraw(pDC, 60, 100, Spectrum);
	} else {
		pDC->TextOut( 50, 50, "DftFft.exe");
		pDC->TextOut( 50, 80, "Wavet@C𗣎Ut[Gϊ܂B");
		pDC->TextOut( 50, 110, "uWavet@Cvuǂݍ݁vIĂB");
		pDC->TextOut( 50, 140, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDftFftView NẌ

BOOL CDftFftView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CDftFftView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CDftFftView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CDftFftView NX̐ff

#ifdef _DEBUG
void CDftFftView::AssertValid() const
{
	CView::AssertValid();
}

void CDftFftView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDftFftDoc* CDftFftView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDftFftDoc)));
	return (CDftFftDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDftFftView NX̃bZ[W nh

void CDftFftView::OnMenuLd() 
{
	GetWavInfo();
	InvalidateRect(NULL, TRUE);
}

void CDftFftView::GetWavInfo()
{
	unsigned long len;
	unsigned char s[10];
	int i;
	long fmtbytes;
	FILE *ifp;
	CString filenameld;
	CFileDialog dlgF(TRUE, "NULL", "*.wav");

	if( dlgF.DoModal() == IDOK)	{
		filenameld = dlgF.GetPathName();
		ifp = fopen( filenameld, "rb" );
		if (ifp != NULL) {
			fread(s, 4, 1, ifp); // "RIFF" 
			bytesinfile = get_ulong(ifp); // total bytes in the file
			fread(s, 8, 1, ifp); // "WAVEfmt" 
			fmtbytes = get_ulong(ifp); // header size
			len = get_ushort(ifp); // 1: pcm
			mono1_stereo2 = get_ushort(ifp); // 1: mono, 2; stereo
			samplingfreq = get_ulong(ifp); // sampling frequency
			bytes_per_sec = get_ulong(ifp); // bytes per second
			chbytes_per_sample = get_ushort(ifp); // channels * bytes per sample
			bitlength = get_ushort(ifp); // bit length
			if( bitlength == 16 ) yrng = 10000; else yrng = 100;
			xstart = 0;
			for (i = 0; i < (fmtbytes-16)/2; i++ ) {
				len = get_ushort(ifp); // skip redundant header information
			}
			do{ // look for "data" chunk
				fread(s, 4, 1, ifp); // expect "data"
				if(((s[0] == 'd')&(s[1] == 'a')&(s[2] == 't')&(s[3] == 'a')) == 0){ // step over chunks unless it's "data" chunk
					len = get_ulong(ifp);
					fseek(ifp, len, SEEK_CUR);
				}else{
					break ;
				}
			} while(1);
			totalbytes = get_ulong(ifp); // total bytes of wav data
			bytes_per_sample = bitlength / 8;
			wavesize = totalbytes / (mono1_stereo2 * bytes_per_sample);
			timelength = (double)wavesize/(double)samplingfreq;
			freq_range = (double)samplingfreq;
			if(bitlength == 16) spec_range = 1000000;
			else spec_range = 3000;
			int i, m;
			short x;
			AllocateMemory();
			if (mono1_stereo2 == 1) {
				for (i = 0; i < wavesize; i++) { // read mono wav data
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					InWave[i] = (double)(x);
				}
			} else {
				for (i = 0; i < wavesize * 2; i++) { // read stereo wav data
					m = i / 2;
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					if(i%2==0) InWave[m] = (double)(x);
					else InWaveR[m] = (double)(x);
				}
			}
			fclose( ifp );
			loaded = TRUE;
			docalc = TRUE;
		}
	}
}

unsigned long CDftFftView::get_ulong(FILE *f)
{
    unsigned char s[4];
	unsigned res;

    if (fread(s, 4, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256LU * (s[1] + 256LU * (s[2] + 256LU * s[3]));
	}
    return res;
}

unsigned CDftFftView::get_ushort(FILE *f)
{
    unsigned char s[2];
	unsigned res;

    if (fread(s, 2, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256U * s[1];
	}
    return res;
}

unsigned CDftFftView::get_ubyte(FILE *f)
{
    unsigned char s[1];
	unsigned res;

    if (fread(s, 1, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0];
	}
    return res;
}

void CDftFftView::AllocateMemory()
{
	if( allocated ) {
		free(InWave);
		free(InWaveR);
	}
	InWave = (double *)calloc(wavesize, sizeof(double));
	InWaveR = (double *)calloc(wavesize, sizeof(double));
	allocated = TRUE;
}

void CDftFftView::InfoDraw(CDC *pDC, int x1, int y1)
{
	char tmpchar[12];

	if( mono1_stereo2 == 1 ) pDC->TextOut( x1 + 10, y1 + 10, "Mono");
	else pDC->TextOut( x1 + 10, y1 + 10, "Stereo");

	pDC->TextOut( x1 + 80, y1 + 10, "Sampling Freq");
	sprintf(tmpchar,"%6d", samplingfreq);
	pDC->TextOut( x1 + 80, y1 + 30, tmpchar);

	pDC->TextOut( x1 + 200, y1 + 10, "Bit Length");
	sprintf(tmpchar,"%3d", bitlength);
	pDC->TextOut( x1 + 200, y1 + 30, tmpchar);

	pDC->TextOut( x1 + 300, y1 + 10, "Total Bytes");
	sprintf(tmpchar,"%8d", totalbytes);
	pDC->TextOut( x1 + 300, y1 + 30, tmpchar);

	pDC->TextOut( x1 + 400, y1 + 10, "Time Length");
	sprintf(tmpchar,"%7.4f", timelength);
	pDC->TextOut( x1 + 400, y1 + 30, tmpchar);
}

void CDftFftView::DftCal(double *InW, double *OutW)
{
	int N = 256; 
	double M_PI = 3.1415928;
	int i,j,k;
	double w1[256], w2[256];
	int x0 = 80;
	int y0 = 200;
	double tReal[256], tImag[256];
	double fReal[256], fImag[256];
	int offset;

	offset = wavesize * fft_position / 100;
	if( offset + N >= wavesize ) offset = wavesize - N;
	for (i = 0; i < N; i++) {
		tReal[i] = InW[i + offset]; tImag[i] = 0.0;
	}

	for ( i = 0; i < N; i++ ) {
		w1[i] = cos( 2 * i * M_PI / N );
		w2[i] = (-1.0) * sin( 2 * i * M_PI / N );
	}

	for ( i = 0; i < N; i++ ) {
		fReal[i] = 0; fImag[i] = 0; k = 0;
		for ( j = 0; j < N; j++ ) {
			k = ( k + i ) % N;
			fReal[i] += tReal[j] * w1[k] - tImag[j] * w2[k];
			fImag[i] += tReal[j] * w2[k] + tImag[j] * w1[k];
		}
	}

	for ( i = 0; i < N; i++ ) {
		OutW[i] = sqrt(fReal[i] * fReal[i] + fImag[i] * fImag[i]);
	}
}

void CDftFftView::FftCal(double *InW, double *OutW)
{
	int N = 256; 
	int P; 
	double M_PI = 3.1415928;
	int N_2 = N/2;
	int i,j,k,kp,m,h;
	double m_double;
	double w1, w2;
	double t1,t2,s1,s2;
	double tri[256];
	double fReal[256], fImag[256];
	int offset;

	i = N; P = 0;
	while (i != 1) {
		i = i / 2;
		P++;
	}

	offset = wavesize * fft_position / 100; 
	if( offset + N >= wavesize ) offset = wavesize - N;
	for (i = 0; i < N; i++) {
		fReal[i] = InW[i + offset]; fImag[i] = 0.0;
	}

	for ( i = 0; i < N_2; i++ ) {
		tri[i] = cos( 2 * i * M_PI / N );
		tri[i + N_2] = (-1.0) * sin( 2 * i * M_PI / N );
	}

	j = 0;
	for ( i = 0; i <= N-2; i++ ) {
		if (i < j) {
			t1 = fReal[j]; fReal[j] = fReal[i]; fReal[i] = t1;
			t2 = fImag[j]; fImag[j] = fImag[i]; fImag[i] = t2;
		}
		k = N_2;
		while (k <= j) {
			j = j - k; k = k/2;
		}
		j = j + k;
	}

	for ( i = 1; i <= P; i++ ) {
		m_double = pow(2.0, double(i));
		m = int(m_double);
		h = m/2;
		for ( j = 0; j < h; j++ ) {
			w1 = tri[j*(N/m)];
			w2 = tri[j*(N/m) + N_2];
			for( k = j; k < N; k+=m ) {
				kp = k + h;
				s1 = fReal[kp] * w1 - fImag[kp] * w2;
				s2 = fReal[kp] * w2 + fImag[kp] * w1;
				t1 = fReal[k] + s1; fReal[kp] = fReal[k] - s1; fReal[k] = t1;
				t2 = fImag[k] + s2; fImag[kp] = fImag[k] - s2; fImag[k] = t2;
			}
		}
	}

	for ( i = 0; i < N; i++ ) {
		OutW[i] = sqrt(fReal[i] * fReal[i] + fImag[i] * fImag[i]);
	}
}

void CDftFftView::FftDraw(CDC *pDC, int x0, int y0, double *Xfr)
{
	double start_fr, end_fr, mid_fr;
	double tmp_xfr[256];
	int	i;
	char freq_char[15];
	char mag_char[15];
	int yscale = 100;
	int xscale = 510;
	double xstep = 2.0;

	CPen	myPen;
	CPen*	pOldPen;
	
	start_fr = 0.0;
	end_fr = freq_range;
	mid_fr = freq_range / 2.0;

	sprintf(freq_char,"%9.1f", start_fr);
	pDC->TextOut(x0 - 50, y0 + 130, freq_char);
	sprintf(freq_char,"%9.1f", mid_fr);
	pDC->TextOut(x0 + 220, y0 + 130, freq_char);
	sprintf(freq_char,"%9.1f", end_fr);
	pDC->TextOut(x0 + 460, y0 + 130, freq_char);
	pDC->TextOut(x0 + 540, y0 + 130,"[Hz]");

	pDC->TextOut(x0 - 30, y0 + 100 - 8,"0.0");
	sprintf(mag_char,"%10.1f", spec_range );
	pDC->TextOut(x0 - 40, y0 - 20, mag_char);
	
	myPen.CreatePen(PS_DOT, 1, RGB(100,100,100));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 0; i <= 5; i++) {
		pDC->MoveTo(x0, y0 + i * yscale/4);
		pDC->LineTo(x0 + xscale, y0 + i * yscale/4);
	}

	for(i = 0; i <= 10; i++) {
		pDC->MoveTo(x0 + i * (xscale / 10), y0);
		pDC->LineTo(x0 + i * (xscale / 10), y0 + yscale*5/4);
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	pDC->MoveTo(x0, y0);
	pDC->LineTo(x0 + xscale, y0);
	pDC->MoveTo(x0, y0 + yscale*5/4);
	pDC->LineTo(x0 + xscale, y0 + yscale*5/4);
	pDC->MoveTo(x0, y0);
	pDC->LineTo(x0, y0 + yscale*5/4);
	pDC->MoveTo(x0 + xscale, y0);
	pDC->LineTo(x0 + xscale, y0 + yscale*5/4);
	
	myPen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 0; i < 256; i++) {
		tmp_xfr[i] = Xfr[i] / (spec_range / yscale);
	}

	xstep = 2.0 * samplingfreq / freq_range;

	for(i = 0; i < 256-1; i++) {
		if( (i+1)*xstep <= xscale ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 100 - (int)(tmp_xfr[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 100 - (int)(tmp_xfr[i+1]));
		}
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}

void CDftFftView::OnMenuItr() 
{
	CDlgIteration dlg;

	dlg.m_itr = Iteration;
	if (dlg.DoModal() == IDOK) {
		Iteration = dlg.m_itr;
		docalc = TRUE;
		InvalidateRect(NULL, TRUE);
	}	
}

void CDftFftView::OnMenuRng() 
{
	CDlgScale dlg;

	dlg.m_srng = spec_range;
	dlg.m_frng = freq_range;
	if (dlg.DoModal() == IDOK) {
		spec_range = dlg.m_srng;
		freq_range = dlg.m_frng;
		InvalidateRect(NULL, TRUE);
	}	
}

void CDftFftView::OnMenuFft() 
{
	CDlgFft dlg;

	if( !sel_fft ) dlg.m_fft1 = 0;
	else dlg.m_fft1 = 1;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fft1 == 0 ) sel_fft = FALSE;
		else sel_fft = TRUE;
		docalc = TRUE;
		InvalidateRect(NULL, TRUE);
	}	
}

void CDftFftView::OnMenuFftpos() 
{
	CDlgFftPos dlg;

	dlg.m_fftpos = fft_position;
	if (dlg.DoModal() == IDOK) {
		fft_position = dlg.m_fftpos;
		docalc = TRUE;
		InvalidateRect(NULL, TRUE);
	}		
}

void CDftFftView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 12; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 6; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);
	
	CView::OnPrint(pDC, pInfo);
}
